// https://forex-station.com/viewtopic.php?p=1295413951#p1295413951
// https://forex-station.com/viewtopic.php?p=1295413968#p1295413968
// modified by banzai; July/2/20
// thanks to jeanlouie codes and templates @ https://www.forexfactory.com/jeanlouie
//------------------------------------------------------------------
//**************************************************
//*  RoundNrMulti.mq4 (No Copyright)               *
//*                                                *
//*  Draws horizontal lines at round price levels  *
//*                                                *
//*  Written by: Totoro                            *
//**************************************************

#property indicator_chart_window

enum LineStyleMenu
{
   LineSolid,
   LineDash,
   LineDot,
   LineDashDot,
   LineDashDotDot
};
//extern string LineStyleInfo  = "0=Solid,1=Dash,2=Dot,3=DashDot,4=DashDotDot";
extern string              note1                 = "------------------------------";
extern int                 Line1Space            = 10; // 1 unit = 0.01 of basic value (e.g. 1 USD cent)
extern color               Line1Color            = clrDarkGreen; //clrDeepPink;
extern LineStyleMenu       Line1Style            = 2;
extern string              note2                 = "------------------------------";
extern int                 Line2Space            = 8;
extern color               Line2Color            = clrLightGreen;
extern LineStyleMenu       Line2Style            = 2;
extern string              note3                 = "------------------------------";
extern int                 Line3Space            = 7;
extern color               Line3Color            = clrLightBlue;
extern LineStyleMenu       Line3Style            = 2;
extern string              UniqueLineID          = "FxRoundNrMulti";

//template code start1
extern string              note4                 = "------------------------------";
extern bool                btn_show              = true;                                //btn__show
extern ENUM_BASE_CORNER    btn_corner            = CORNER_LEFT_UPPER; // chart corner for anchoring
extern string              btn_pressed           = "RNrM";                       //btn__pressed text
extern string              btn_unpressed         = "RNrM";                     //btn__unpressed text
extern int                 btn_offset_x          = 20;                                     //btn__x
extern int                 btn_offset_y          = 40;                                     //btn__y
extern int                 btn_width             = 60;                                 //btn__width
extern int                 btn_height            = 20;                                //btn__height
extern int                 btn_font_size         = 10;                             //btn__font size
extern color               btn_font_clr          = clrBlack;                      //btn__font color
extern color               btn_bg_color          = clrGray;                         //btn__bg color
extern color               btn_border_clr        = clrWhiteSmoke;               //btn__border color
extern string              aButtonName           = "RoundNumberMulti_button";
extern string              note5                 = "------------------------------";
//template code end1

double Hoch, Tief;
bool FirstRun = true;
//------------------------------------------------------------------
int OnInit()
{
//template code start2  
   if(btn_show){CreateButton();}
   if(!btn_show){ObjectDelete(0,aButtonName);}
//template code end2
   return(0);
}
//------------------------------------------------------------------
int deinit()
{

   //template code start3
   ObjectDelete(0,aButtonName);
   //template code end3

   double Oben    = MathRound(110*Hoch)/100;
   double Unten   = MathRound(80*Tief)/100;
 
   double AbSpace = 0.01*Line1Space;   
   for(double i=0; i<=Oben; i+=AbSpace)
   {
      if(i<Unten) continue;
      ObjectDelete(UniqueLineID+DoubleToStr(i,2));
   }
   
   AbSpace = 0.01*Line2Space;
   for(double j=0; j<=Oben; j+=AbSpace)
   {
      if(j<Unten) continue;
      ObjectDelete(UniqueLineID+DoubleToStr(j,2));
   }
   
   AbSpace = 0.01*Line3Space;
   for(double k=0; k<=Oben; k+=AbSpace)
   {
      if(k<Unten) continue;
      ObjectDelete(UniqueLineID+DoubleToStr(k,2));
   }
   
   return(0);
}
//------------------------------------------------------------------
int start()
{
//template code start4
      if(!ObjectGetInteger(0,aButtonName,OBJPROP_STATE)){
//template code end4

   if(FirstRun)
   {
      Hoch = NormalizeDouble( High[iHighest(NULL,0,MODE_HIGH,Bars-1,0)], 2 );
      Tief = NormalizeDouble( Low[iLowest(NULL,0,MODE_LOW,Bars-1,0)], 2 );
      FirstRun = false;
   }
   DrawLines();

//template code start5
      }   
//template code end5

   return(0);
}
//------------------------------------------------------------------
void DrawLines()
{
   double Oben    = MathRound(110*Hoch)/100;
   double Unten   = MathRound(80*Tief)/100;

   double AbSpace = 0.01*Line1Space;
   for(double i=0; i<=Oben; i+=AbSpace)
   {
      if(i<Unten) continue;
      string StringNr1 = DoubleToStr(i,2); // 2 digits number in object name
      if (ObjectFind(UniqueLineID+StringNr1) != 0) // HLine not in main chartwindow
      {                     
         ObjectCreate(UniqueLineID+StringNr1, OBJ_HLINE, 0, 0, i);
         ObjectSet(UniqueLineID+StringNr1, OBJPROP_STYLE, Line1Style);
         ObjectSet(UniqueLineID+StringNr1, OBJPROP_COLOR, Line1Color);
      }
      else
      {
         ObjectSet(UniqueLineID+StringNr1, OBJPROP_STYLE, Line1Style);
         ObjectSet(UniqueLineID+StringNr1, OBJPROP_COLOR, Line1Color);
      }
   }

   AbSpace = 0.01*Line2Space;
   for(double j=0; j<=Oben; j+=AbSpace)
   {
      if(j<Unten) continue;
      string StringNr2 = DoubleToStr(j,2);
      if (ObjectFind(UniqueLineID+StringNr2) != 0)
      {
         ObjectCreate(UniqueLineID+StringNr2, OBJ_HLINE, 0, 0, j);
         ObjectSet(UniqueLineID+StringNr2, OBJPROP_STYLE, Line2Style);
         ObjectSet(UniqueLineID+StringNr2, OBJPROP_COLOR, Line2Color);
      }
      else
      {
         ObjectSet(UniqueLineID+StringNr2, OBJPROP_STYLE, Line2Style);
         ObjectSet(UniqueLineID+StringNr2, OBJPROP_COLOR, Line2Color);
      }
   }
   
   AbSpace = 0.01*Line3Space;
   for(double k=0; k<=Oben; k+=AbSpace)
   {
      if(k<Unten) continue;
      string StringNr3 = DoubleToStr(k,2);
      if (ObjectFind(UniqueLineID+StringNr3) != 0)
      {                     
         ObjectCreate(UniqueLineID+StringNr3, OBJ_HLINE, 0, 0, k);
         ObjectSet(UniqueLineID+StringNr3, OBJPROP_STYLE, Line3Style);
         ObjectSet(UniqueLineID+StringNr3, OBJPROP_COLOR, Line3Color);
      }
      else
      {
         ObjectSet(UniqueLineID+StringNr3, OBJPROP_STYLE, Line3Style);
         ObjectSet(UniqueLineID+StringNr3, OBJPROP_COLOR, Line3Color);
      }
   }

//   WindowRedraw();
}
//------------------------------------------------------------------
//template start codes6
void CreateButton()
{
   ButtonCreate(NULL,aButtonName,0,btn_offset_x,btn_offset_y,btn_width,btn_height,btn_corner,btn_unpressed,"Arial",btn_font_size,btn_font_clr,btn_bg_color,btn_border_clr,false,true,false,false,0);
}
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
{
int i, lookForLength;
string name;

   if (id == CHARTEVENT_OBJECT_CLICK && sparam==aButtonName) 
   { 
      if(ObjectGetInteger (0,aButtonName,OBJPROP_STATE)){
         ObjectSetString  (0,aButtonName,OBJPROP_TEXT,btn_pressed); //off

         lookForLength = StringLen(UniqueLineID);
         for (i=ObjectsTotal()-1; i>=0; i--) 
             {
              name = ObjectName(i);  
              if (StringSubstr(name,0,lookForLength) == UniqueLineID) 
              ObjectDelete(name);
             }

         } // if(ObjectGetInteger (0,aButtonName,OBJPROP_STATE))
      if(!ObjectGetInteger(0,aButtonName,OBJPROP_STATE)){
         ObjectSetString  (0,aButtonName,OBJPROP_TEXT,btn_unpressed); //on
         DrawLines();
         } //if(!ObjectGetInteger(0,aButtonName,OBJPROP_STATE))
    } //if (id == CHARTEVENT_OBJECT_CLICK && sparam==aButtonName)
} //void OnChartEvent
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID   = 0,                                 // chart's ID
                  const string            name       = "Button",                         // button name
                  const int               sub_window = 0,                            // subwindow index
                  const int               x          = 0,                               // X coordinate
                  const int               y          = 0,                               // Y coordinate
                  const int               width      = 50,                              // button width
                  const int               height     = 18,                             // button height
                  const int               mycorner   = CORNER_LEFT_UPPER,
                  const string            text       = "Button",                                // text
                  const string            font       = "Arial",                                 // font
                  const int               font_size  = 10,                                 // font size
                  const color             clr        = clrBlack,                          // text color
                  const color             back_clr   = C'236,233,216',              // background color
                  const color             border_clr = clrNONE,                         // border color
                  const bool              state      = false,                       // pressed/released
                  const bool              back       = false,                      // in the background
                  const bool              selectable = true,                   //object can be selected
                  const bool              selection  = false,                      // highlight to move
                  const bool              hidden     = false,              // hidden in the object list
                  const long              z_order    = 0)                   // priority for mouse click
  {
   ResetLastError();
   ObjectCreate    (chart_ID,name,OBJ_BUTTON,          sub_window,0,0);
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,   x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,   y);
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,       width);
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,      mycorner);
   ObjectSetString (chart_ID,name,OBJPROP_TEXT,        text);
   ObjectSetString (chart_ID,name,OBJPROP_FONT,        font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,    font_size);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,       clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,     back_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,        back);
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,       state);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,  selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,    selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,      hidden);
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,      z_order);
   return(true);
  }
//+------------------------------------------------------------------+
//template end codes6
